"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

// Generated by CoffeeScript 2.3.2

/**
 * This adds a .displayName to function components created using flow() or pipe() (from lodash/fp).
 *
 * Specifically, any declaration of a capitalized name initialized to a call to
 * a function named `flow` or `pipe` gets followed by an assignment to its
 * `.displayName` property.
 */
function _default(_ref) {
  var t = _ref.types;
  var visitor; // Api

  visitor = {
    VariableDeclarator: function VariableDeclarator(_ref2) {
      var _ref2$node = _ref2.node,
          id = _ref2$node.id,
          init = _ref2$node.init,
          parentPath = _ref2.parentPath;
      var ref;

      if (!(id.type === 'Identifier' && /^[A-Z]/.test(id.name))) {
        return;
      }

      if (init.type !== 'CallExpression') {
        return;
      }

      if (!(init.callee.type === 'Identifier' && ((ref = init.callee.name) === 'flow' || ref === 'pipe'))) {
        return;
      }

      parentPath.insertAfter(t.expressionStatement(t.assignmentExpression('=', t.memberExpression(t.identifier(id.name), t.identifier('displayName')), t.stringLiteral(id.name))));
      return null;
    }
  };
  return {
    name: 'transform-react-display-name-pipe',
    visitor: visitor
  };
}

;